Doomsday Engine - Bug #1977

Doomsday crashes with Intel Chipset
2015-02-12 14:50 - Incantator

Status: Closed Start date: 2015-02-12
Priority: Low % Done: 100%
Assignee: skyjake

Category: 3rd party compatibility

Target version: 1.15.4

Description

Hello. This time I'm having a trouble with Doomsday itself. | don't know if | have to report this in dengine.net or here but just decided
to post it here.

As | said before, I'm keep using the latest stable Doomsday. When | try to open the Doomsday.exe, it just crashes (~ has stopped
working error message). | gathered every information possible before asking this, and I've seen somewhere that (1) Doomsday is
somewhat not compatible with Intel graphics chipset and (2) it requires OpenGL 2.0 or higher. Now my laptop supports OpenGL 2.1
so it shouldn't be a problem, | guess. My computer is using Mobile Intel(R) 4 Series Express Chipset Family (it's a laptop!).

So can't | use Doomsday engine at all? I've seen someone just using the older version but... | just hope there's a way to solve this.
Doomsday.out reports this:

0: ..\Bin\Doomsday.exe

1: -basedir

2: D:\rest\Games\Doom\Doomsday/

3: -sfxchan

4:16

5: -nohighpat

6: -nohightex

7: -notexcomp

8: -game

9: doom1-ultimate

10: -iwad

11: DADOOM.WAD

12: -userdir

13: C:\Users\Incantator\Documents\Doomsday Frontend\runtime/
RenderSystem: Loading shader definitions from read-only archive entry "data/renderer.pack/
shaders.dei" [path "/data/doomsday.pk3/data/renderer.pack/shaders.dei"]
from archive in read-only "(basedir)\data\doomsday.pk3"

Thanks again.

Related issues:

Related to Bug #1879: [Windows] Doomsday randomly fails to start when/after I... Closed 2014-10-16
Related to Bug #2063: GLFramebuffer > GLTarget: Segmentation Violation [Intel] Rejected 2015-05-20
Related to Bug #2183: Incomplete attachments uncaught exception (jdrp hud wea... Closed 2016-11-08
Precedes Feature #2116: Compatibility with limited FBO functionality (old Ope... Closed 2015-02-13

Associated revisions

Revision ea1d417b - 2015-09-05 14:21 - skyjake
libgui|Windows|Linux: Report missing OpenGL entry points

Exception thrown, aborts startup.

IssuelD #1977

Revision d49157¢8 - 2015-09-06 11:09 - skyjake

OpenGL|libgui: Check EXT variants of functions not present in OpenGL 2.1

IssuelD #1977

2024-04-09 1/8




Revision d4dde8fb - 2015-09-08 20:23 - skyjake

OpenGL|libgui: Even more robust setup for GLFramebuffer

There are now five alternative configurations for the framebuffer.
The objective is to find the one that supports the most renderer
features.

According to the OpenGL Wiki, old GPUs may not allow having both depth
and stencil attachments unless they use the same target. Therefore,

if the depth24+stencil8 texture/renderbuffer fails, the fallbacks now

test for simpler color+depth only configurations, although that will

prevent sky masking from working.

IssuelD #1977

Revision b7690605 - 2015-09-27 10:07 - skyjake

Fixed|GL|libgui: Better compatibility with older OpenGL drivers

More robust FBO configuration that is more likely to work with
OpenGL 2.1 drivers.

However, some renderer features may be currently unsupported if the
FBO is not full-featured.

IssuelD #1977

History

#2 - 2015-02-13 08:46 - skyjake

The most likely reason for this crash is that the way we do antialiasing in 1.14 is not compatible with the Intel GPU you have. | recommend trying to
launch with the "-nofsaa" option. When using the frontend, you can add this option in Settings > Developer > Custom options.

#3 - 2015-02-13 09:43 - Incantator

Hm, probably | just have to wait until | buy a decent desktop; the doomsday.out is almost the same except the additional command.

Application path: D:\rest\Games\Doom\Doomsday\Bin\Doomsday.exe

Created a new 32.0 MB memory volume.

Executable: Doomsday Engine 1.14.5 (Stable 32-bit #1265) Jun 19 2014 13:11:35
Command line options:

0: ..\Bin\Doomsday.exe

1: -basedir

2: D:\rest\Games\Doom\Doomsday/
3: -sfxchan
4:16

5: -notexcomp
6: -game

7: doom1-ultimate

8: -iwad

9: D:\DOOM.WAD

10: -nofsaa

11: -userdir

12: C:\Users\Incantator\Documents\Doomsday Frontend\runtime/

RenderSystem: Loading shader definitions from read-only archive entry "data/renderer.pack/
shaders.dei" [path "/data/doomsday.pk3/data/renderer.pack/shaders.dei"]

from archive in read-only "(basedir)\data\doomsday.pk3"

And it still crashes.

#4 - 2015-02-13 09:58 - skyjake
- Related to Bug #1879: [Windows] Doomsday randomly fails to start when/after loading shader definitions added

#5 - 2015-02-13 09:59 - skyjake

Did you try the unstable 1.15.0? We've fixed some potential causes for a startup crash.

#6 - 2015-02-13 10:28 - Incantator

I've just tried it, yet with the same result:

Application path: D:\rest\Games\Doom\Doomsday1\Bin\Doomsday.exe
Created a new 32.0 MB memory volume.
Executable: Doomsday Engine 1.15.0 [#1503] (Unstable 32-bit) Feb 12 2015 14:46:56
Command line options:

0: ..\Bin\Doomsday.exe

: -basedir

: D:\rest\Games\Doom\Doomsday1/

: -sfxchan

16

: -notexcomp

-game

: doom1-ultimate

: -iwad

9: D:\rest\Games\Doom\Doomsday 1\bin\DOOM.WAD

10: -userdir

11: C:\Users\Incantator\Documents\Doomsday Frontend\runtime/
RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/

shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

OND O A WN =

This is slightly different from previous, though. Same with the -nofsaa option.

#7 - 2015-02-13 10:30 - skyjake

Ok, what if you also add the "-vvv" option in 1.15.0? This will produce a lot more log output that may contain some hints for us. Please use
http://pastebin.com/ (or similar) or attach the log here as a file.

#8 - 2015-02-13 10:32 - Incantator

Incantator wrote:
I've just tried it, yet with the same result:

Application path: D:\rest\Games\Doom\Doomsday1\Bin\Doomsday.exe
Created a new 32.0 MB memory volume.

Executable: Doomsday Engine 1.15.0 [#1503] (Unstable 32-bit) Feb 12 2015 14:46:56
Command line options:

0: ..\Bin\Doomsday.exe

: -basedir

: D:\rest\Games\Doom\Doomsday 1/

: -sfxchan

16

: -notexcomp

-game

: doom1-ultimate

: -iwad

9: D:\rest\Games\Doom\Doomsday1\bin\DOOM.WAD

10: -userdir

11: C:\Users\Incantator\Documents\Doomsday Frontend\runtime/
RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/

shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

OND O A WN =

This is slightly different from previous, though. Same with the -nofsaa option.

#9 - 2015-02-13 10:41 - Incantator

- File -vvv -nofsaa.txt added

Sorry, it says 'modify' in Korean but it should be 'reply'... what the...
Sure, here is the log file.

By the way, I've noticed that as | install it, Avira detects a file as an adware. It seems to be related with C++ 2013 redistributable, but | don't know
what it is exactly and why it is detected as a virus.
#10 - 2015-02-13 10:55 - skyjake

Incantator wrote:

Sure, here is the log file.
Thanks! From the looks of it, the next thing that should be happening is that the main window appears and OpenGL drawing begins. | wonder if an
older stable release like 1.12.2 works on your computer, since there the OpenGL rendering was still done in a simpler manner.

By the way, I've noticed that as | install it, Avira detects a file as an adware. It seems to be related with C++ 2013 redistributable, but | don't know

what it is exactly and why it is detected as a virus.

The Visual C++ redistributable contains a couple of supporting libraries by Microsoft. Could be a false positive from Avira?

#11 - 2015-02-13 11:03 - Incantator

skyjake wrote:
Incantator wrote:
Sure, here is the log file.

Thanks! From the looks of it, the next thing that should be happening is that the main window appears and OpenGL drawing begins. | wonder if
an older stable release like 1.12.2 works on your computer, since there the OpenGL rendering was still done in a simpler manner.

Thanks. | think | just have to get a desktop next time. Hoped it to be helpful to developers but | think we just ended up the same conclusion as before
haha. Thanks for taking time with this problem.

By the way, I've noticed that as | install it, Avira detects a file as an adware. It seems to be related with C++ 2013 redistributable, but | don't
know what it is exactly and why it is detected as a virus.

The Visual C++ redistributable contains a couple of supporting libraries by Microsoft. Could be a false positive from Avira?

| think so. | was just wondering if it has something to do with this problem.

#12 - 2015-05-20 13:01 - skyjake
- Related to Bug #2063: GLFramebuffer > GLTarget: Segmentation Violation [Intel] added

#13 - 2015-05-20 13:01 - skyjake
- Tags set to VideoCardDriver, IntelGraphics

#14 - 2015-09-04 20:27 - Drako

| have the same graphics card (Mobile Intel 4 Series Express Chipset Family) and exactly the same issue. | have figured out that the newest version
of Doomsday which works is 1.10.4. It seems that the problem is that the OpenGL driver returns that the version 2.1 is supported while in fact only the
version 1.1 is supported. Hopefully my info will help you to fix that issue.

#15 - 2015-09-04 20:37 - danij

Thanks for the mfo It might also help to see dxdiag mfo for your driver and chlpset if you can, see here
h

#16 - 2015-09-05 04:06 - Drako
- File files.zip added

Hi. | attach (files.zip) dxdiag files (both x32 and x64). | also attach a few files from OpenGL Extensions Viewer 4.3.8. Now it seems that what | wrote
about OpenGL version previously is false because renderer tests passed up to version 2.1 of OpenGL (previously | used version 4.2.8 of OpenGL
Extensions Viewer where the renderer test fails if the OpenGL version is higher than 1.1 - that is why | wrote what | wrote in my previous comment).

#17 - 2015-09-05 04:30 - Drako
- File doomsday.out added

| also attach doomsday.out file (-vvv -nofsaa from the newest version 1.15.3). The way this version does not work is, after pressing "Play" in Frontend
it goes full screen, display all white and does nothing. | have to use the task manager to kill the process.
#18 - 2015-09-06 07:44 - Drako
That is the message which | get when I try to run Doomsday 2 build 1709 (Sep 6, 2015):

Application path: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

Created a new 32.0 MB memory volume.

Config::read: /packs/net.dengine.stdlib/modules/Config.de is newer than modules/Config,
rerunning the script

A : Detected new build: 1459 => 1709

Executable: Doomsday Engine 2.0.0 [#1709] (Unstable 32-bit) Sep 6 2015 03:49:36
Command line options:

0: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/

shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

(getAllOpenGLEntryPoints) Required OpenGL function missing: glBindFramebuffer
Application terminated due to exception:

(getAllOpenGLEntryPoints) Required OpenGL function missing: glBindFramebuffer

Restoring original display mode due to shutdown

According to this website: https://www.opengl.org/sdk/docs/man/html/gIBindFramebuffer.xhtml the function glBindFramebuffer is supported from
version 3.0 of OpenGL. It would be great if you manage to replace that function by something supported by OpenGL 2.0 (or 2.1).

#19 - 2015-09-06 10:22 - skyjake

Yeah, those functions should be accessed via the extensions (e.g., EXT_framebuffer_object).

Support for FBOs is required, though, either via normal or extension functions.

#20 - 2015-09-06 11:11 - skyjake
- Tags changed from VideoCardDriver, IntelGraphics to VideoCardDriver, IntelGraphics, OpenGL

Let me know if tomorrow's build 1710 works any better/differently.

#21 - 2015-09-07 05:33 - Drako
Ok. The build 1710 gives the following error:

Application path: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe
Created a new 32.0 MB memory volume.

Config::read: /packs/net.dengine.stdlib/modules/Config.de is newer than modules/Config,
rerunning the script

A : Detected new build: 1459 => 1710

Executable: Doomsday Engine 2.0.0 [#1710] (Unstable 32-bit) Sep 7 2015 03:48:05
Command line options:

0: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/

shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

GLFramebuffer: Required GL_ARB_framebuffer_object is missing!

A : Texture-based framebuffer failed: [ConfigError] (GLTarget::validate) Incomplete
attachments

Trying fallback without depth/stencil texture

(GLTarget::validate) Incomplete attachments

Application terminated due to exception:

(GLTarget::validate) Incomplete attachments

Restoring original display mode due to shutdown

It seems that GL_ARB_framebuffer_object is supported from version 3.0 of OpenGL. If you look at the report generated by OpenGL Extensions
Viewer 4.3.8 (which | attached some time ago in the file files.zip) then you will see that what is supported by my card is GL_EXT_framebuffer_object. |
found on the internet ( https://www.opengl.org/discussion_boards/showthread.php/177252-Regarding-GL_EXT_framebuffer_object ) that
GL_ARB_framebuffer_object and GL_EXT_framebuffer_object are quite similar. Will it be possible to use GL_EXT_framebuffer_object instead of
GL_ARB_framebuffer_object in the doomsday project? It would be really great.

BTW. Do you know that project: https://www.opengl.org/sdk/tools/GLIntercept/ ? It seems it allows to "emulate" old versions of OpenGL for debugging
purposes.

#22 - 2015-09-07 05:49 - Drako

| do not know if it helps but let me share it with you. | edited deng_gui.dll and changed ARB to EXT at offset 0x25dd27 (ie | changed
GL_ARB_framebuffer_object to GL_EXT_framebuffer_object). It did not fix the problem (of course) but now the error message is slightly different:

Application path: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe
Created a new 32.0 MB memory volume.

Config::read: /packs/net.dengine.stdlib/modules/Config.de is newer than modules/Config,
rerunning the script

A : Detected new build: 1459 => 1710

Executable: Doomsday Engine 2.0.0 [#1710] (Unstable 32-bit) Sep 7 2015 03:48:05
Command line options:

0: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/

shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

GLFramebuffer: Texture-based framebuffer failed: [ConfigError] (GLTarget::validate)
Incomplete attachments

Trying fallback without depth/stencil texture

(GLTarget::validate) Incomplete attachments

Application terminated due to exception:

(GLTarget::validate) Incomplete attachments

Restoring original display mode due to shutdown

#23 - 2015-09-07 12:18 - skyjake

Thanks for the details. Indeed it should be checking for the EXT_framebuffer_object extension rather than ARB. I'll change that and see if there are
other alternatives for configuring the framebuffer to get around that attachments error.

#24 - 2015-09-07 13:47 - skyjake
- Category set to 3rd party compatibility
- Status changed from New to In Progress

- Priority changed from Normal to Low

#25 - 2015-09-07 19:04 - skyjake

@Drako: Could you post an updated log with -vvv, please? It would help to see more detail about what is happening after "GLFramebuffer:
Texture-based framebuffer failed".

#26 - 2015-09-07 19:24 - Drako
- File doomsday.out added

Please see the attached file. Hopefully it will help.

#27 - 2015-09-08 05:47 - Drako
- File doomsday.out added

Now 1711 build. The error changed:

Application path: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

Created a new 32.0 MB memory volume.

Config::read: /packs/net.dengine.stdlib/modules/Config.de is newer than modules/Config,
rerunning the script

A : Detected new build: 1459 => 1711

Executable: Doomsday Engine 2.0.0 [#1711] (Unstable 32-bit) Sep 8 2015 04:03:20
Command line options:

0: C:\Program Files (x86)\Doomsday 2.0.0\bin\Doomsday.exe

RenderSystem: Loading shader definitions from read-only archive entry "renderer.pack/
shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
shaders.dei"] from archive in read-only "(basedir)\data\

net.dengine.client.pack”

A : Loading shader definitions from read-only archive entry "renderer.pack/
lensflares.pack/shaders.dei" [path "/data/net.dengine.client.pack/renderer.pack/
lensflares.pack/shaders.dei"] from archive in read-only "(basedir)\data\
net.dengine.client.pack”

GLFramebuffer: Texture-based framebuffer failed: [ConfigError] (GLTarget::validate)
Incomplete attachments

Trying fallback without depth/stencil texture

A : Unified depth/stencil buffer failed: [ConfigError] (GLTarget::validate) Incomplete
attachments

Trying to allocate separately

A : Separate depth and stencil buffers failed: [ConfigError] (GLTarget::validate)
Unsupported (0x8cdd)

Final fallback: disabling render-to-texture

(GLTarget::validate) Incomplete attachments

Application terminated due to exception:

(GLTarget::validate) Incomplete attachments

Restoring original display mode due to shutdown
| also attach -vvv log (build 1711)

Hopefully you can get something from that log.

#28 - 2015-09-08 11:56 - skyjake

Seeing as all of the fallback configurations failed, it leads me to suspect that your GPU and/or OpenGL drivers actually are not capable of supporting
the way Doomsday does its rendering in version 1.11 onwards.

Furthermore, we are soon planning to require OpenGL 3.3 in the unstable builds. | was hoping to find a workaround that could be applied in the 1.15
branch for this issue, where the requirement is OpenGL 2.1, however this doesn't look very good.

#29 - 2015-09-08 14:29 - skyjake

If the OpenGL Extensions Viewer app shows these for you, could you check what is supported in the Pixel Formats tab under Color Buffer Modes,
Depth Buffer Modes, and Stencil Buffer Modes?

#30 - 2015-09-08 19:28 - Drako
- File 1.jpg added
- File 2.jpg added

For now | only can send you files 1.jpg and 2.jpg. Later | will have more time to look at this.

There is a renderer test in OpenGL extensions viewer which allows to choose pixel format from 0 to 51, | tested 0, 1, 2, 30, 31, 32, 50, and 51 and
they worked. (there is also some raport from OpenGL extensions viewer is in the file files.zip)

#31 - 2015-09-08 20:26 - skyjake

Hmm, | can't see the information | was looking for in those. However, I've added a couple of further fallbacks to the FBO setup. Let's see if they allow
the engine to launch. If so, we can then look into working around the visual artifacts caused by the potentially missing FBO capabilities.

#32 - 2015-09-09 04:19 - Drako

- File PixelFormats.xls added

| was able to extract some data from OpenGL extensions viewer 4.3.8. Please see the xIs file. Pixel formats are numbered from 1 to 51. There are
other fields to look at (see files 1.jpg and 2.jpg), | copied only those which | thing are meaningful. If you would like to see values of other fields please
let me know.

#33 - 2015-09-09 05:32 - Drako
- File doomsday.out added

This build (1712) is better. The engine starts, | was able to see this short tutorial in the beginning. But then after choosing an IWAD folder the whole
screen goes white and nothing happens (actually does not matter what folder | choose, in fact the same happens if | click Cancel instead of choosing
a folder.. | have to use the Task Manager

to kill the process. | attach -vvv doomsday.out file.

Actually, before | choose the IWAD folder | can click an triangle in the right upper corner where it says: "Renderer features unavailable: sky mask,
lensflare depth”
#34 - 2015-09-09 05:52 - Drako
- File 1712_GLscreen.jpg added

(build 1712) In fact after the engine starts, | am able to write in the console and choose options "Video, network, updater, packages" | can also see

"about... GL" (I attach the screen - 1712_GLscreen).

Update: When | moved the doom.WAD file to the data folder it has been found automatically and | was able to play doom 1 or ultimate doom.

However | do not know where to put the 3D models files so that they get loaded automatically.

#35 - 2015-09-09 09:34 - skyjake

This is the 2.0 branch, which means resource packs aren't fully supported at the moment (short answer: you currently need to load them manually

using command line options). For more information, see the blog post: http://dengine.net/forums/viewtopic.php?f=24&{=2019

| think it's better that we apply these OpenGL changes to the 1.15 branch where you can use the Doomsday Frontend (Snowberry) to load resource

packs like before. Also as | mentioned, the 2.0 branch will require OpenGL 3.3 soon.

#36 - 2015-09-09 09:34 - skyjake
- Target version set to 1.15.4

- % Done changed from 0 to 50

#37 - 2015-09-09 17:38 - skyjake

- Assignee set to skyjake

#38 - 2015-09-10 16:36 - Drako
Ok. Thanks. | am looking forward new build of 1.15.4.

#39 - 2015-09-29 19:30 - Drako
- File doomsday.out added
- File doomsday.out added

| put it here because it is most likely related to the Intel Chipset. The problem is | cannot change the resolution in Video settings. Doomsday stops
responding after | click new resolution. | have to use task manager to kill the process. Exactly the same happens in 1.15.4 (1732) (running either

snowberry.exe or doomsday.exe) and in v2 (1730). | attach doomsday. out files.

#40 - 2015-10-07 19:09 - skyjake
- Status changed from In Progress to Closed

- % Done changed from 50 to 100

#41 - 2015-10-07 19:12 - skyjake
- Precedes Feature #2116: Compatibility with limited FBO functionality (old OpenGL drivers) added

#42 - 2016-11-09 08:56 - skyjake
- Related to Bug #2183: Incomplete attachments uncaught exception (jdrp hud weapons) added

Files

-vvv -nofsaa.txt 446 KB 2015-02-13 Incantator
files.zip 314 KB 2015-09-05 Drako
doomsday.out 549 KB 2015-09-05 Drako
doomsday.out 261 KB 2015-09-07 Drako
doomsday.out 262 KB 2015-09-08 Drako
1.jpg 138 KB 2015-09-08 Drako
2.jpg 137 KB 2015-09-08 Drako
PixelFormats.xls 30.5 KB 2015-09-09 Drako
doomsday.out 337 KB 2015-09-09 Drako
1712_GLscreen.jpg 67.8 KB 2015-09-09 Drako
doomsday.out 2.16 MB 2015-09-29 Drako
doomsday.out 322 KB 2015-09-29 Drako
